LeetCode 1. Two Sum(easy)

题目1.Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

解题思路:
一、暴力破解法 时间复杂度为O(n^2)。
由题目可知一定存在nums[i]和nums[j],使得nums[i]+nums[j]==target。
采用两次遍历即可,注意j=i+1 是为了访问nums[i]之后的元素。

class Solution {
    public int[] twoSum(int[] nums, int target) {
        int res[]=new int[2];
        for(int i=0;i<nums.length;i++){
            for(int j=i+1;j<nums.length;j++){
                if(nums[i]+nums[j]==target){
                    res[0]=i;
                    res[1]=j;  
                    return res;
                }
            } 
        }
        return res;
    }
}

二、HashMap法 时间复杂度为O(n)。
定义map,存储<数值,数值在nums中的索引>,遍历数组nums[],如果map中不存在target-nums[i],则将其put,若存在则从map中取出target-nums[i]对应的索引,最后返回即可。

class Solution {
    public int[] twoSum(int[] nums, int target) {
        int res[]=new int[2];
        if(nums==null||nums.length<=1) return res;
        HashMap<Integer,Integer> map=new HashMap<Integer,Integer>();
        for(int i=0;i<nums.length;i++){
            int num=nums[i];
            int val=target-num;//要找的第二个值
            if(!map.containsKey(val)){
                map.put(num,i);
            }else{
                res[0]=i;
                res[1]=map.get(val);
                return res;
            }
        }
        return res;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值